//This program was used to make a list of the width of each 4x6 font character
//for use with pictionary.
//NOTE: I just threw this proggy together... there's probably some unnecessary stuff in here..
//Alexander Biemann.


// C Source File
// Created 8/11/00; 7:07:36 PM

// Available Patches
// #define USE_GRAY_PATCH
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define SAVE_SCREEN
#include <nostub.h>  // Make NoStub Program
#include <all.h>     // Include All Header Files

int _ti89;           // Produce .89Z File
int _ti92plus;       // Produce .9XZ File

// Main Function
int _main()
{
  HANDLE dialog;
  int dialogkey,key;		//declare integer variables
  unsigned int chrnum,clow,chi;
  char buffer[8],temp[3],chreq[2],size[2],chrdisp[3];
  chrnum=0;				//initiate variables (ensure they are clean)
  clow=0;
  chi=0;
  key=0;
  buffer[4]=0;				//ensures clean space (removes crap)
top:  
  dialog=DialogNewSimple(150,70);
  DialogAddTitle(dialog,"4x6 Font width counter",BT_OK,BT_CANCEL);
  DialogAddText(dialog,16,15,"by Alexander Biemann (8/12/2K)");
  DialogAddRequest (dialog, 12, 30, "Start char code(>13):", 0, 3,6);
  DialogAddRequest (dialog, 12, 40, "End char code(<256):", 4, 3,6);
  dialogkey=DialogDo(dialog,CENTER,CENTER,buffer,NULL); //show dialog & wait for ENTER to be pushed
  strncpy(temp,buffer,3);
  temp[3]=0;
  clow=atoi(temp); 				//convert BUFFER (low entry) to number
  strncpy(temp,buffer+4,3);
  temp[3]=0;
  chi=atoi(temp); 				//convert BUFFER (high entry) to number
  HeapFree(dialog);  				//Remove Dialog screen from view.
  if (dialogkey==264) goto exit;		//ESC pressed
  if ((chi>255)||(chi<14)||(chi<clow)) goto top;
  if ((clow>255)||(clow<14)||(clow>chi)) goto top;
  for (chrnum=clow;chrnum<=chi;chrnum++)
  {
  	ClrScr();							//Clear screen
  	chreq[0]=chrnum;					//convert integer to char.
  	sprintf(chrdisp,"%d\0",chrnum);		//convert integer to string
  	chreq[1]=0;						//make sure to end string, else it spills into rest of RAM when printed
	sprintf(size,"%d\0",DrawStrWidth(chreq,F_4x6));//convert integer result (width of char) to char
  	DrawStr(1,30,"Char Code\0",A_NORMAL);
  	DrawStr(20,40,chrdisp,A_NORMAL);		//display character number
  	DrawStr(70,30,"Char\0",A_NORMAL);
  	FontSetSys(0);
  	DrawStr(80,40,chreq,A_NORMAL);		//display character.
  	FontSetSys(1);
  	DrawStr(110,30,"Size\0",A_NORMAL);
  	DrawStr(120,40,size,A_NORMAL); 		//display size of character
	key=ngetchx();						//pause
	if (key==264) goto exit;				//exit if ESC pressed
  }
  goto top;
  
exit:
return 0;	
}
